<?php 

error_reporting(E_ALL & ~E_NOTICE); //this line controls the level of error reporting on this particular page.
//var_dump($_POST);
//phpinfo(); I'm on PHP 5.6. Will have to update.

$did_submit = $_POST['did_submit'];
//1. confirm the form got submitted:

if($did_submit){

//2. clean the data:

//filter_var($dirty_data, FILTER, options) cleans our data
 $name = trim(filter_var($_POST["name"], FILTER_SANITIZE_STRING));
 $email = trim(filter_var($_POST["email"], FILTER_SANITIZE_EMAIL));    
 //trim is a good thing to add whenever users are going to be typing a value.

 $radio_selection = filter_var($_POST["radio_selection"], FILTER_SANITIZE_STRING); 
 //because I am going to check against known values, I am not going to trim.
 

 //checkbox selection is special as it is multi dimensional:
 $check_selection = $_POST["check_selection"]; 
 //no [] in the check_selection as the [] in the HTML puts the item into an array.
 

 if(is_array($check_selection)){
 	$check_selection = filter_var_array($check_selection, FILTER_SANITIZE_STRING); 
 	//goes through each item in the array to clean it. will not do trim here either.
 	$check_selection_message = join(", ", $check_selection);
 }


 $message = trim(filter_var($_POST["message"], FILTER_SANITIZE_STRING));
 $subject = filter_var($_POST["subject"], FILTER_SANITIZE_STRING); //same reason as radio_selection

//3. validate the data like we did in JS only now in PHP
$valid = true;

//if any test fails... $valid will be set to false

if($name == ''){
	$valid = false;
	$error_message .= 'You did not enter your name. <br>';
}


//! means not - because of that the bad email renders as true
if( !filter_var($email, FILTER_VALIDATE_EMAIL) ){
	$valid = false;
	$error_message .= 'Please provide a valid email address.<br>';
}

$check_radio_values = ['radio1', 'radio2', 'radio3' ];

	if( !in_array($radio_selection, $check_radio_values) ){
  //if our values are not in the array, well then.... 
		$valid = false;
		$error_message .= 'You need to choose a radio option.<br>';
	}

	$num = count($check_selection); //gets the number of items in the array

	$check_checked_values = ['check1', 'check2', 'check3'];
 	//this loops through the array to get each item...  	

 if(is_array($check_selection)){
 	 	for($i = 0; $i<$num; $i++){

 		if(!in_array($check_selection[$i], $check_checked_values) ){
 			//if it comes back false then... we know they messed with us.
 			$valid = false;
 			$error_message .= 'You did not select a proper checkbox value. You Hacker! <br>';
 			break;
 		}
 	}
 }else{
 			$valid = false;
 			$error_message .= 'You did not select a proper checkbox value. <br>';
 }	

 	if(strlen($message) == 0){
 		$valid = false;
 		$error_message .= 'You forgot to fill out the message area. <br>';
 	}

 	$check_subjects = ['Job Inquiry', 'General Question'];

 	if(!in_array($subject, $check_subjects)){
 		$valid = false;
 		$error_message .= 'You forgot to choose a subject.';

 	}

 	if($valid){
//or $valid == true
	//create the content for the mail function
	$to = 'trish@example.com'; //a valid email address goes here
	$to = 'trishzwei@gmail.com';
	//watch out that if you use your gmail acct it may still go into your spam as gmail knows it didn't come from itself. Your inbox may need some training.... 

	$mail_subject = $subject;

	$body = "Name: $name \n";
	$body .= "Email: $email \n";
	$body .= "The radio chosen: $radio_selection \n";
	$body .= "The boxes selected are: $check_selection_message \n";
	$body .= "Message: \n";
	$body .= $message;


	$header = "From: $email \r\n";
	$header .= "Reply-to: $email \r\n";

	//this does not work on our local servers and for good reason
	$mail = mail($to, $subject, $body, $header);	

//this is here to simulate if the mail function was successful. get rid of this when you move from local server to your host server
//	$mail = 1; //simulating success condition
//  $mail = 0; //testing fail condition	

		if($mail == 1){
			//success.... do nothing we can shorten this conditional but we'll do that later.
		}else{
			$error_message = 'We are sorry but we were unable to process your request.';
		}
 	}
}//end if did_submit






